#pragma once
#include <cstdint>
#include "driver/gpio.h"

using Callback = void(*)(void *);

enum class Lvl {reset, set};

class GPIO_drv
{
public:
    GPIO_drv();

    virtual ~GPIO_drv();

    void     init(gpio_num_t but,
                  gpio_mode_t mode, 
                  gpio_pullup_t pu = GPIO_PULLUP_DISABLE, 
                  gpio_pulldown_t pd = GPIO_PULLDOWN_DISABLE);

    void     enableINT(gpio_int_type_t type, Callback ptr);

    void     setLvl(Lvl lvl);
    Lvl      getLvl();
    inline gpio_num_t getGpioNum(void) {return button;}

private:
    gpio_num_t button;
    Callback clbk_ptr;
    static bool isr_service_installed;
};

