#pragma once
#include <cstdint>
#include <driver/spi_master.h>
#include <driver/gpio.h>

class SPI_drv {
public:
	SPI_drv();

	void 			init(spi_host_device_t host, int freq = 1000000, gpio_num_t cs_pin = GPIO_NUM_NC, bool useMiso = false, uint8_t spiMode = 0, uint32_t flags = 0);
	void    		transfer(std::uint8_t* data, size_t dataLen);
	void    		receive(std::uint8_t* rx_data, size_t dataLen);
	std::uint8_t 	transferByte(std::uint8_t value);
	void			cmd_write(std::uint16_t command, std::uint8_t* transfer_data, std::uint8_t byte2write);
	void			cmd_read (std::uint16_t command, std::uint8_t* read_data,std::uint8_t byte2read);
	
private:
  spi_device_handle_t m_handle;
};